'ToDo:
'Print number variables (Dec2, etc)
'Change Z address?
'Read back pixels and OR them with the pixels to be printed to print "on top"
'Adjust things so that printing can be done anywhere and not restricted to Y lines (Use Z addresss?)
'Draw graphics (box / line / circle)
'Plot/UnPlot

$define CheckBusy 0 '1 = Do checks to see if the GLCD is still busy, 0 = Assume that the GLCD is not busy

Dim GSendData As Byte
Dim GReadData As Byte
Dim GAddressX As Byte
Dim GAddressY As Byte
Dim GCtrX As Byte
Dim GCtrY As Byte
Dim GLastRS As Bit
Dim GChar As Byte 'ASCII number of character
Dim GFontPointer As Word
Dim GStringPointer As Word
$if (_core = 16)
Dim GCtr As Byte
Dim GCtrTo As Byte
Dim GString As String * 32 
$endif

Dim GPrintImageDontSetup As Bit
Dim GPrintImageXsize As Byte
Dim GPrintImageYsize As Byte   
Dim GPrintImageDataPointer As Word
Dim GPrintImageXStart As Byte

Dim GPrintDelay As Byte 'Delay between each byte sent to the LCD to create animation
Dim GPrintCharDelay As Byte 'Delay between each character printed to animate text

' ----- GCSNone -----
GCSNone_:
    GCS1 = 1
    GCS2 = 1
    GCS3 = 1
    Return
' ----- -----  

' ----- GCSAll -----
GCSAll_:
    GCS1 = 0
    GCS2 = 0
    GCS3 = 0
    Return
' ----- ----- 

' ----- GCheckBusy -----
'$if CheckBusy = 1
GCheckBusy_:
    GLastRS = GRS
    GDTris = 255 'Input
    GRS = 0 'Command
    GRW = 1 'Read
    GoSub GDoCheckBusy_
    GRS = GLastRS
    Clear GDTris
    Return    
'$endif

GDoCheckBusy_:
    Repeat
        GE = 0
        'DelayUS 1
        GE = 1
    Until GDPort & %10000000 = 0
    GE = 0
    Return
' ----- -----

' ----- GSend/Print/Com ----- 'Send data to a graphical LCD
GSend Macro  P1 'Send a byte to the LCD without changing any of the RS / RW / etc pins
#if (Prm_Count > 1)
	#error "GSend - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GSend - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GSend - Data(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GSendData
		#endif
		GoSub GSend_
	#endif
#endif
Endm 

GPrint Macro  P1 'Send data (not a command) to the LCD
#if (Prm_Count > 1)
	#error "GPrint - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GPrint - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GPrint - Data(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GSendData
		#endif
		GRS = 1
		GoSub GSend_
	#endif
#endif
Endm 

GCmd Macro  P1 'Send a command to the LCD
#if (Prm_Count > 1)
	#error "GCmd - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GCmd - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GCmd - Data(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GSendData
		#endif
		GRS = 0
		GoSub GSend_
	#endif
#endif
Endm 

GSend_:
    GDPort = GSendData
    DelayUS 1
GSendCurData_:
    GoSub GClockE_
    $if CheckBusy = 1
    GoSub GCheckBusy_
    $endif
    Return
' ----- ----- 

' ----- GInit -----
GInit Macro 'Initialise the display 
    GoSub GInit_
Endm

GInit_:
    Clear GDTris 'Output
    Clear GDPort
    GoSub GCSAll_    
    GE = 0 ': DelayUS 1
    GRS = 0 ': DelayUS 1
    GRW = 0
    GSend %11000000 'Set the Z address to 0  
    GPrintDelay = 0
    GPrintCharDelay = 0
    Return
' ----- -----   

' ----- GOnOff -----
GOnOff Macro  P1 'Turn the display on or off
#if (Prm_Count > 1)
	#error "GOnOff - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GOnOff - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GOnOff - OnOff(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GSendData
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GSendData
		#endif
        GoSub GOnOff_
	#endif
#endif
Endm

GOnOff_:
	GoSub GCSAll_
	GRS = 0
	GDPort = GSendData | %111110
	GoSub GSendCurData_
    Return
' ----- ----- 

' ----- GClockE -----
GClockE Macro 'Tells the display to look at current data etc
    GoSub GClockE_
Endm

GClockE_:
    GE = 1
    DelayUS 1 
    GE = 0
    Return
' ----- -----    

' ----- GReadStatus -----
GReadStatus Macro 'Read the current status from the LCD
    GoSub GReadStatus_
Endm

GReadStatus_:
    GDTris = 255
    GRS = 0 'Command
    GRW = 1
    DelayUS 1
    GE = 1
    GReadData = GDPort
    GE = 0
    GRW = 0
    Clear GDTris
    Return
' ----- -----
    
' ----- GCls -----    
GCls Macro 'Clear screen by writing it full of blank ( :D ) - could be done faster with the reset pin?
    GoSub GCls_
Endm

GCls_:
    GoSub GCSAll_
    GDPort = %00111110 'Display off
    GoSub GSendCurData_
    For GCtrX = 0 To 7
        GRS = 0 'Command    
        GDPort = %10111000 | GCtrX 'Append the x address to the end
        GoSub GSendCurData_ 'Send X Address
        GDPort = %01000000 'Send Y Address of 0
        GoSub GSendCurData_
        GRS = 1 'Data
        GDPort = 0
        For GCtrY = 0 To 63
            GoSub GSendCurData_ 
            'Display's Y Address increments automatically
        Next
    Next
    GRS = 0 'Command
    GDPort = %00111111 'Display on
    GoSub GSendCurData_    
    Return
' ----- -----

' ----- GGotoX -----
GGotoX Macro  P1
#if (Prm_Count > 1)
	#error "GGotoX - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GGotoX - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GGotoX - GGotoX(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressX
		#endif
		GoSub GGotoX_
	#endif
#endif
Endm

GGotoX_: 'Note that X and Y have been swopped due to the display having swopped them in the first place... ?
    GoSub GCSNone_
    If GAddressX < 64 Then
        GCS1 = 0
    ElseIf GAddressX < 128 Then
        GCS2 = 0
        GAddressX = GAddressX - 64
    Else
        GCS3 = 0
        GAddressX = GAddressX - 128
    EndIf
GGotoXSend_:
    GRS = 0 'Command
    '(Assume we're in write mode and not read mode) 
    GDPort = %01000000 | GAddressX
    GoSub GSendCurData_
    Return    
' ----- -----

' ----- GGotoY -----
GGotoY Macro  P1 
#if (Prm_Count > 1)
	#error "GGotoY - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GGotoY - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GGotoY - GGotoY(Param1) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressY
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressY
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressY
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressY
		#endif
		GoSub GGotoY_
	#endif
#endif
Endm

GGotoY_: 'Note that X and Y have been swopped due to the display having swopped them in the first place... ?
    GRS = 0 'Command
    '(Assume we're in write mode and not read mode) 
    GDPort = %10111000 | GAddressY
    GoSub GSendCurData_
    Return
' ----- -----

' ----- GGotoXY -----
GGotoXY Macro  P1, P2 
#if (Prm_Count > 2)
	#error "GGotoXY - Too many parameters"
#else
	#if (Prm_Count < 2)
		#error "GGotoXY - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GGotoXY - X(Param1) Should be a Byte variable or number"
		#endif
		#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
			#error "GGotoXY - Y(Param2) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_2 == Byte)
			BYTE_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num8)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num16)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num32)
			NUM_BYTE P2, GAddressY
		#endif
		GoSub GGotoXY_
	#endif
#endif
Endm

GGotoXY_: 'Note that X and Y have been swopped due to the display having swopped them in the first place... ?
    GoSub GGotoX_ 'Sets the correct CS as well
    GoSub GGotoY_
    Return
' ----- -----

' ----- GPrintAt -----
GPrintAt Macro  P1, P2, P3 '??? Parameters here are X, Y - make them Y, X like the rest?
#if (Prm_Count > 3)
	#error "GPrintAt - Too many parameters"
#else
	#if (Prm_Count < 3)
		#error "GPrintAt - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GPrintAt - X(Param1) Should be a Byte variable or number"
		#endif 
		#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
			#error "GPrintAt - Y(Param2) Should be a Byte variable or number"
		#endif
		#if(Prm_3 != Byte) && (Prm_3 != Num8) && (Prm_3 != Num16) && (Prm_3 != Num32)
			#error "GPrintAt - Data(Param3) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_2 == Byte)
			BYTE_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num8)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num16)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num32)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_3 == Byte)
			BYTE_BYTE P3, GSendData
		#endif
		#if (Prm_3 == Num8)
			NUM_BYTE P3, GSendData
		#endif
		#if (Prm_3 == Num16)
			NUM_BYTE P3, GSendData
		#endif
		#if (Prm_3 == Num32)
			NUM_BYTE P3, GSendData
		#endif
		GoSub GGotoXY_
		GRS = 1
		GoSub GSend_
	#endif
#endif
Endm
' ----- -----
    
' ----- GPrintImage ----- *** Copied / modified from S. Wright's SPrintImage ***
GPrintImage Macro  P1, P2, P3 'Label, [Y, X] - *always* requires the dimensions at the start of the CData section
Clear GAddressX
Clear GCtrY
#if (Prm_Count > 3)
	#error "GPrintImage - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GPrintImage - Too few parameters"
	#else
		#if(Prm_1 != LABEL) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Word)
			#error "GPrintImage - Label(Param1) Should be a pointer to a Label"
		#endif
		#if (Prm_Count > 1)
			#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
				#error "GPrintImage - Yline(Param2) Should be a Byte variable or number"
			#endif
		#endif
		#if (Prm_Count > 2)
			#if(Prm_3 != Byte) && (Prm_3 != Num8) && (Prm_3 != Num16) && (Prm_3 != Num32)
				#error "GPrintImage - XPos(Param3) Should be a Byte variable or number"
			#endif
		#endif
		#if (Prm_1 == LABEL)
			@ LABEL_WORD P1, GPrintImageDataPointer
		#endif
		#if (Prm_1 == Num16)
			@  LABEL_WORD P1, GPrintImageDataPointer
		#endif
		#if (Prm_1 == Num8)
			@  LABEL_WORD P1, GPrintImageDataPointer
		#endif
		#if (Prm_1 == Word)
			@  LABEL_WORD P1, GPrintImageDataPointer
		#endif
		#if (Prm_Count > 1)
			#if (Prm_2 == Byte)
				BYTE_BYTE P2, GCtrY
			#endif
			#if (Prm_2 == Num8)
				NUM_BYTE P2, GCtrY
			#endif
			#if (Prm_2 == Num16)
				NUM_BYTE P2, GCtrY
			#endif
			#if (Prm_2 == Num32)
				NUM_BYTE P2, GCtrY
			#endif
		#endif
		#if (Prm_Count > 2)
			#if (Prm_3 == Byte)
				BYTE_BYTE P3, GAddressX
			#endif
			#if (Prm_3 == Num8)
				NUM_BYTE P3, GAddressX
			#endif
			#if (Prm_3 == Num16)
				NUM_BYTE P3, GAddressX
			#endif
			#if (Prm_3 == Num32)
				NUM_BYTE P3, GAddressX
			#endif
		#endif
		GoSub GPrintImage_
	#endif
#endif
Endm

GPrintImage_:
    GPrintImageDontSetup = 0
    GPrintImageYsize = CRead GPrintImageDataPointer
    Inc GPrintImageDataPointer
    GPrintImageXsize = CRead GPrintImageDataPointer  
    Inc GPrintImageDataPointer
    GCtrX = GAddressX
    GPrintImageXStart = GAddressX
    GPrintImageXsize = GPrintImageXsize + GAddressX
    GPrintImageYsize = GCtrY + GPrintImageYsize 
      
GDoPrintImage_:      
    Repeat
        If GPrintImageDontSetup = 0 Then GoSub GPrintImageSetup_ 
        Repeat
            GDPort = CRead GPrintImageDataPointer ' Read from memory the GLCD data
            GoSub GSendCurData_
            'DelayMS 30 '!!! Test
            Inc GCtrX                                ' Up the pointers
            Inc GPrintImageDataPointer                         ' Inc the data address pointer
            If GCtrX = 64 Or GCtrX = 128 Then
                GoSub GCSNone_
                If GCtrX = 64 Then 
                    GCS2 = 0
                Else
                    GCS3 = 0
                End If
                Clear GAddressX
                GoSub GGotoXSend_
                GRS = 1 'Data again
            End If
            DelayMS GPrintDelay
        Until GCtrX = GPrintImageXsize                ' Until the whole line has been written
        If GPrintImageDontSetup = 0 Then GCtrX = GPrintImageXStart ' Start again from GAddressX 
        Inc GCtrY                                   ' But move down a line until all screen processed
    Until GCtrY = GPrintImageYsize
    Reset_Bank '??? what's this
	Return
	
GPrintImageSetup_:
        GoSub GCSAll_
        GGotoY GCtrY 'Goto Y first to get the same Y on all chips
        GGotoX GCtrX 'Sets chip-select appropriately
        GRS = 1 'Data now        
        Return    	
' ----- -----

' ----- GSetFont / GPrintCharAt / GPrintStringAt -----
GSetFont Macro  P1
#if (Prm_Count > 1)
	#error "GSetFont - Too many parameters"
#else
	#if (Prm_Count < 1)
		#error "GSetFont - Too few parameters"
	#else
		#if(Prm_1 != LABEL) && (Prm_1 != Num16) && (Prm_1 != Num8) && (Prm_1 != Word)
			#error "GSetFont - Label(Param1) Should be a pointer to a Label"
		#endif
		#if (Prm_1 == LABEL)
			@ LABEL_WORD P1, GFontPointer
		#endif
		#if (Prm_1 == Num16)
			@  LABEL_WORD P1, GFontPointer
		#endif
		#if (Prm_1 == Num8)
			@  LABEL_WORD P1, GFontPointer
		#endif
		#if (Prm_1 == Word)
			@  LABEL_WORD P1, GFontPointer
		#endif
		GoSub GClockE_
	#endif
#endif
Endm

GPrintStringAt Macro  P1, P2, P3, P4 'Y, X, String, [Font]
Clear GStringPointer
#if (Prm_Count > 4)
	#error "GPrintStringAt - Too many parameters"
#else
	#if (Prm_Count < 3)
		#error "GPrintStringAt - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GPrintStringAt - Y(Param1) Should be a Byte variable or number"
		#endif
		#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
			#error "GPrintStringAt - X(Param2) Should be a Byte variable or number"
		#endif
		#if(Prm_3 != String) && (Prm_3 != CHAR) && (Prm_3 != Byte) && (Prm_3 != Num8) && (Prm_3 != Num16) && (Prm_3 != Num32)
			#error "GPrintStringAt - String(Param3) Should be a String or Character"
		#endif		
		#if (Prm_Count > 3)
			#if(Prm_4 != LABEL) && (Prm_4 != Num16) && (Prm_4 != Num8) && (Prm_4 != Word)
				#error "GPrintStringAt - FontLabel(Param4) Should be a pointer to a Label"
			#endif
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GCtrY
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GCtrY
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GCtrY
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GCtrY
		#endif
		#if (Prm_2 == Byte)
			BYTE_BYTE P2, GCtrX
		#endif
		#if (Prm_2 == Num8)
			NUM_BYTE P2, GCtrX
		#endif
		#if (Prm_2 == Num16)
			NUM_BYTE P2, GCtrX
		#endif
		#if (Prm_2 == Num32)
			NUM_BYTE P2, GCtrX
		#endif
		#if (Prm_3 == CHAR)
			@ LABEL_WORD P3, GStringPointer
		#endif
		$if (_core = 16)
		#if (Prm_3 == String)
			NUM_WORD P3, GStringPointer
            GoSub GDoPrintStringAt_
		#endif
		$endif
		#if (Prm_3 == Byte)
			BYTE_BYTE P3, GChar
		#endif
		#if (Prm_3 == Num8)
			NUM_BYTE P3, GChar
		#endif
		#if (Prm_3 == Num16)
			NUM_BYTE P3, GChar
		#endif
		#if (Prm_3 == Num32)
			NUM_BYTE P3, GChar
		#endif		
		#if (Prm_Count > 3)
			#if (Prm_4 == LABEL)
				@ LABEL_WORD P4, GFontPointer
			#endif
			#if (Prm_4 == Num16)
				@  LABEL_WORD P4, GFontPointer
			#endif
			#if (Prm_4 == Num8)
				@  LABEL_WORD P4, GFontPointer
			#endif
			#if (Prm_4 == Word)
				@  LABEL_WORD P4, GFontPointer
			#endif
		#endif
		#if (Prm_3 != String)
		GoSub GPrintStringAt_
		#endif
	#endif
#endif
Endm

$if (_core = 16)
GDoPrintStringAt_:
    GString = GStringPointer
    Clear GStringPointer
    GCtrTo = Len GString
    Dec GCtrTo
    For GCtr = 0 To GCtrTo
      GChar = GString[GCtr]
      If GCtr = 0 Then
        GoSub GPrintStringAt_
      Else
        GoSub GPrintChar_
      End If
    Next
    Return
$endif

GPrintStringAt_: 'If a Char was received the GStringPointer will be 0
    GoSub GPrintImageSetup_
    GPrintImageDontSetup = 1 'No need to do subsequent setups, will be printing in a straight line
    GPrintImageYsize = GCtrY + 1 'Remember that we won't be doing more than one line
    If GStringPointer = 0 Then GoTo GPrintChar_
GPrintStringLoop:
    GChar = CRead GStringPointer
    'PORTA = GCtrX '!
    'PORTB = GChar '!
GPrintChar_:
    If GChar <> 0 Then    
        GChar = GChar - 32
        GPrintImageDataPointer = GFontPointer + GChar * 6
        GPrintImageXsize = GCtrX + 6
        'DelayMS 2000 '!            
        GoSub GDoPrintImage_   
        Dec GCtrY 'Bring it back to the same line again 
        If GStringPointer = 0 Then Return 'Character was printed, not string
        Inc GStringPointer        
        DelayMS GPrintCharDelay        
        GoTo GPrintStringLoop
    End If
    'DelayMS 1000 '!
    'High PORTA: DelayMS 5000: Low PORTA '!
    Return
' ----- -----    

' ----- GReadAt -----
GReadAt Macro  P1, P2 '??? Parameters here are X, Y - make them Y, X like the rest?
#if (Prm_Count > 2)
	#error "GReadAt - Too many parameters"
#else
	#if (Prm_Count < 2)
		#error "GReadAt - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GReadAt - X(Param1) Should be a Byte variable or number"
		#endif
		#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
			#error "GReadAt - Y(Param2) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_2 == Byte)
			BYTE_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num8)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num16)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num32)
			NUM_BYTE P2, GAddressY
		#endif
		GoSub GReadAt_
	#endif
#endif
Endm

GReadAt_: 'Note that X and Y have been swopped due to the display having swopped them in the first place... ?
    GoSub GGotoXY_ 
    '-Set up-
    GDTris = 255 'Input
	GRW = 1 'Read mode
	'-Busy Check-
    GoSub GDoCheckBusy_
    '-Dummy Read-
	GRS = 1 'Data
	GE = 1
	'DelayUS 1
	GE = 0
	'-Busy Check-
	GRS = 0 'Command 
    GoSub GDoCheckBusy_
    '-Read-
	GRS = 1 'Data
	GE = 1
	GReadData = GDPort
	GE = 0
	'-Clean up-
	GRW = 0 'Write
	Clear GDTris
    Return
' ----- -----

' ----- GPlot -----
GPlot Macro  P1, P2 '??? Parameters here are X, Y - make them Y, X like the rest?
#if (Prm_Count > 2)
	#error "GPlot - Too many parameters"
#else
	#if (Prm_Count < 2)
		#error "GPlot - Too few parameters"
	#else
		#if(Prm_1 != Byte) && (Prm_1 != Num8) && (Prm_1 != Num16) && (Prm_1 != Num32)
			#error "GPlot - X(Param1) Should be a Byte variable or number"
		#endif
		#if(Prm_2 != Byte) && (Prm_2 != Num8) && (Prm_2 != Num16) && (Prm_2 != Num32)
			#error "GPlot - Y(Param2) Should be a Byte variable or number"
		#endif
		#if (Prm_1 == Byte)
			BYTE_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num8)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num16)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_1 == Num32)
			NUM_BYTE P1, GAddressX
		#endif
		#if (Prm_2 == Byte)
			BYTE_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num8)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num16)
			NUM_BYTE P2, GAddressY
		#endif
		#if (Prm_2 == Num32)
			NUM_BYTE P2, GAddressY
		#endif
		GSendData = GAddressY // 8
		GAddressY = GAddressY / 8
		GoSub GReadAt_
		GSendData = 1 << GSendData 		
		GSendData = GSendData | GReadData
		GoSub GGotoXSend_ 'Display's address was incremented automatically by the read operation
		GRS = 1 'Data
		GoSub GSend_
	#endif
#endif
Endm
