'Driving a KS0108 LCD

Device 18F452 
Xtal = 4

@CONFIG_REQ
@__CONFIG Config1H, OSCS_OFF_1 & HS_OSC_1
@__CONFIG Config2L, BOR_OFF_2 & BORV_20_2 & PWRT_ON_2
@__CONFIG Config2H, WDT_OFF_2 & WDTPS_128_2
@__CONFIG Config3H, CCP2MX_ON_3
@__CONFIG Config4L, STVR_ON_4 & LVP_OFF_4 & DEBUG_OFF_4
@__CONFIG Config5L, CP0_ON_5 & CP1_ON_5 & CP2_ON_5 & CP3_ON_5

All_Digital = On

Dim GDPort As PORTD
Dim GDTris As TRISD
Dim GRS As PORTC.1 'Data (1) / Command (0)
Dim GRW As PORTC.2 'Read (1) / Write (0)
Dim GE As PORTC.3 'Enable
Dim GCS1 As PORTC.4 'Chip Select 1 
Dim GCS2 As PORTC.5 'Chip Select 2
Dim GCS3 As PORTC.6 'Chip Select 3

Dim GData As Byte
Dim GAddr As Byte
Dim i As Byte 'Counter
Dim j As Byte
Dim strTest As String * 32
Dim f As Float

' DelayMS 500 'Give things time to stabilise?

TRISA = 0 'Output
TRISB = 0 'Output
TRISC = 0 'Output

GoTo Start

Include "GMacros.inc"

Start:
    GInit
    GSetFont Font
    GCls

    GPrintStringAt 0,0,"Text spans 3 segments of the LCD"
    DelayMS 2000
    GCls 
    f = 3.14
    strTest = "Numeric Variable Values: " + Str$(Dec2 f)
    GPrintStringAt 0,0, strTest
    DelayMS 2000
    GCls
    GPrintCharDelay = 50
    GPrintStringAt 1,10,"Animated text"
    DelayMS 2000
    GCls
    For i = 0 To 63
        j = i * 3
        GPlot j, i
        GPlot 0, i
        DelayMS 50
    Next
    DelayMS 2000
    GCls
    GPrintImage Leaf, 1, 92
    GPrintImage Leaf, 1, 16
    DelayMS 2000
    GCls
    GPrintDelay = 10
    GPrintImage Leaf
    Stop

Include "GFont.inc"

Leaf: 
CData 7,61,_
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_
      $FF,$FF,$7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_
      $FF,$7F,$7F,$3F,$3F,$3F,$3F,$3F,$3F,$9F,$9F,$9F,$9F,$9F,$9F,$9F,_
      $9F,$9F,$9F,$9F,$BF,$3F,$3F,$3F,$3F,$7F,$FF,$FF,$FF,_ ' Y_Bytes 0
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_
      $3F,$0F,$C0,$00,$03,$FF,$FF,$7F,$3F,$1F,$8F,$C7,$E3,$F1,$F9,$F8,_
      $FC,$FC,$FE,$FE,$FE,$7F,$7F,$3F,$1F,$9F,$9F,$CF,$CF,$EF,$E7,$E7,_
      $EF,$FF,$FF,$FF,$3F,$0F,$C1,$F0,$FC,$FF,$FF,$FF,$FF,_ ' Y_Bytes 1
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$3F,$1F,$87,$C3,$F0,_
      $FC,$FE,$FF,$FF,$F0,$F1,$F8,$FC,$FE,$FF,$FF,$FF,$FF,$7F,$3F,$1F,_
      $8F,$E7,$E3,$F1,$F8,$FC,$FE,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$3F,_
      $8F,$C7,$E3,$F8,$FC,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_ ' Y_Bytes 2
      $FF,$FF,$FF,$FF,$FF,$FF,$3F,$0F,$C3,$E1,$F8,$FC,$FE,$FF,$FF,$07,_
      $8F,$FF,$FF,$FF,$FF,$FF,$7F,$3F,$1F,$8F,$C7,$F1,$F8,$FC,$FE,$FF,_
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$1F,$0F,$27,$33,$18,$9C,$9E,_
      $3F,$3F,$3F,$3F,$7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_ ' Y_Bytes 3
      $FF,$FF,$FF,$FF,$07,$00,$F8,$FF,$FF,$FF,$FF,$FF,$FF,$1F,$80,$78,_
      $3F,$1F,$0F,$87,$C3,$C1,$C4,$E6,$E7,$E3,$F3,$F3,$F3,$F9,$F9,$F9,_
      $F9,$F9,$FD,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$3F,$1F,$9F,$CF,$CF,_
      $EF,$E7,$E7,$E7,$F6,$F6,$F0,$F1,$E7,$FF,$FF,$FF,$FF,_ ' Y_Bytes 4
      $FF,$FF,$FF,$81,$00,$1E,$1F,$8F,$CF,$C7,$E7,$E3,$F0,$F8,$FC,$FC,_
      $FE,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F,$7F,$7F,$7F,$3F,$3F,$3F,$3F,_
      $9F,$9F,$CF,$E7,$E7,$F3,$F1,$F9,$FC,$FC,$FE,$FF,$FF,$FF,$FF,$FF,_
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_ ' Y_Bytes 5
      $FF,$FF,$FF,$FF,$FF,$FE,$F8,$E0,$E7,$E3,$F3,$F1,$F9,$F9,$FC,$FC,_
      $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC,$FE,$FE,$FE,$FF,$FF,$FF,_
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,_
      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF   ' Y_Bytes 6
